"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const nd_gpio_rf_1 = require("nd-gpio-rf");
class GpioRFOut {
    constructor(RED, node, config) {
        this.RED = RED;
        this.config = config;
        this.node = node;
        this.init();
    }
    init() {
        this.node.status({});
        if (this.config.pin) {
            this.gpio = new nd_gpio_rf_1.GpioRF();
            this.node.status({ fill: "green", shape: "dot", text: "connected" });
        }
        this.node.on('input', (msg) => {
            if (this.gpio) {
                if (msg.payload) {
                    this.sendRFCode(msg);
                }
            }
            else {
                this.node.status({ fill: "red", shape: "dot", text: "no connected pin" });
            }
        });
        this.node.on('close', () => {
        });
    }
    sendRFCode(msg) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log("Start Send......");
            this.node.status({ fill: "yellow", shape: "dot", text: "Start Send......" });
            // let payload = msg.payload as any;
            // let times = payload.micros as Array<number>;
            // if (!times || !times.length) {
            //     console.log("invalid times")
            //     this.node.status({fill:"red", shape:"dot", text: "invalid times"});        
            //     return false;
            // }
            // let timesLength = times.length;
            // let nextValue = 1;
            // let nextIndex = 0;
            // if (times[0] === 0 || times[0] === 1) {
            //     nextIndex = 1;
            //     nextValue = times[0];
            // } 
            // let getNext = () => {
            //     let next = {value: nextValue, micro: times[nextIndex]}
            //     nextIndex++;
            //     nextValue = nextValue ? 0 : 1;
            //     return next;
            // }
            // let nextTime = microtime.now();
            // while (nextIndex < timesLength) {
            //     let next = getNext();
            //     nextTime = nextTime + next.micro;
            //     let mnow = microtime.now();
            //     if (mnow > nextTime)
            //         continue;
            //     let value = next.value;                
            //     this.pin.write(value as any);
            //     while (microtime.now() < nextTime) { };
            // }
            // console.log("Stop Send......")
            // this.node.status({fill:"yellow", shape:"dot", text: "Stop Send:" + times.length});
            return true;
        });
    }
}
module.exports = (RED) => {
    function CreateNode(config) {
        RED.nodes.createNode(this, config);
        new GpioRFOut(RED, this, config);
    }
    RED.nodes.registerType("gpio-rf-sender", CreateNode);
};
